CREATE OR REPLACE PROCEDURE CONSUMDATA(InData in DATE, InCiutat in INTEGER)
IS 
  --	
  -- Cursor que carregem tots els consums del mes i any introduit.
  --
  vMes Varchar(2);
  vAny Varchar(4);
   
  Cursor result is SELECT (SELECT IDCONTRACTE FROM COMPTADORS WHERE COMPTADORS.IDCOMPTADOR = HISTORICLECTURES.IDCOMPTADOR) AS IDCONTRACTE,
                          SUM(CONSUM) AS CONSUM,
			  (SELECT POTENCIACONTRACTE FROM COMPTADORS WHERE COMPTADORS.IDCOMPTADOR = HISTORICLECTURES.IDCOMPTADOR) AS POTENCIA
                     FROM HISTORICLECTURES
			 WHERE TO_CHAR(DATALECTURA,'MM') = vMes
			   AND TO_CHAR(DATALECTURA,'YYYY')= vAny
			   HAVING SUM(CONSUM) > (SELECT (AVG(CONSUM)*1.80)
	   				  	   FROM HISTORICLECTURES
				                  WHERE TO_CHAR(DATALECTURA,'MM') = vMes
			                            AND TO_CHAR(DATALECTURA,'YYYY')= vAny
                         			    AND IDCOMPTADOR IN (SELECT DISTINCT(IDCOMPTADOR) 
                                               				  FROM COMPTADORS
                         					  	 WHERE ACTIU = 1
                    					        	   AND IDPOBLACIO = InCiutat))
                    GROUP BY IDCOMPTADOR
                    ORDER BY 2;					
  --
  -- Variables de treball
  --
  V_CAMP_NUL    EXCEPTION;
  V_NODADES     EXCEPTION;
  v_tant        NUMBER;
  v_in          VARCHAR2(500);
  vConsum       NUMBER;
  rsp           varchar2(100);
  err_num       NUMBER;
  err_msg       VARCHAR2(100);
  outContracte  VARCHAR2(15);
  outPotencia   NUMBER;
  outConsum     NUMBER;
  
BEGIN
   v_in := 'Data:'||InData||', Ciutat:'||inCiutat;
   --
   -- Comprovar que parametre d'entrada
   --
   IF (TRIM(inData)     IS NULL) THEN
      RAISE V_CAMP_NUL;
   END IF;
   IF (TRIM(inCiutat)     IS NULL) THEN
      RAISE V_CAMP_NUL;
   END IF;
   --
   -- Mes i any per al cursor
   --
   vMes := TO_CHAR(inData,'MM');
   vAny := TO_CHAR(inData,'YYYY');
   --
   -- Consulta per saber la mitja total de la ciutat
   --
   BEGIN
     SELECT (AVG(CONSUM)*1.80) 
       INTO vConsum
       FROM HISTORICLECTURES
      WHERE TO_CHAR(DATALECTURA,'MM') = vMes
        AND TO_CHAR(DATALECTURA,'YYYY')= vAny
        AND IDCOMPTADOR IN (SELECT IDCOMPTADOR 
                              FROM COMPTADORS
                             WHERE ACTIU = 1
     			       AND IDPOBLACIO = InCiutat); 
   EXCEPTION
     WHEN NO_DATA_FOUND THEN RAISE V_NODADES;
   END;							
   --
   -- Capcelera del llistat mostrant ciutat, mitja total i el mes i any de la consulta.
   --
   rsp := 'Ciutat: '||InCiutat||', Consum Total :'||Round(vConsum,2)||', Mes : '||vMes||', Any : '||vAny;
   DBMS_OUTPUT.put_line(rsp);
   --
   -- Obertura del cursor per poder mostrar tots els contractes que superen el 80%
   --
   OPEN result;  
   FETCH result INTO outContracte,outConsum,outPotencia;  
   WHILE RESULT%FOUND LOOP
         v_tant := 100;
		 IF (vConsum>0) THEN
		    v_tant := ROUND(((outConsum * 100) / vConsum)-100,2); 
		 END IF;               
         rsp := 'Contracte : '||outContracte||', Potencia : '||outPotencia||', % Consum :'||v_tant;
         DBMS_OUTPUT.put_line(rsp);		 
         FETCH result INTO outContracte,outConsum,outPotencia;   
   END LOOP;  
   -- Fi de la consulta
   CLOSE result;
   --
   -- Excepcions  
   --
   EXCEPTION
    WHEN V_NODADES THEN
         RSP := 'ERROR: Ciutat sense consum';
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.CONSULTAVELLS', v_in, 'RSP: '||RSP);
         DBMS_OUTPUT.put_line(rsp);
         COMMIT;
    WHEN V_CAMP_NUL THEN
         RSP := 'ERROR: No pot haver camps NULL';
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.CONSULTAVELLS', v_in, 'RSP: '||RSP);
         DBMS_OUTPUT.put_line(rsp);
         COMMIT;
    WHEN OTHERS THEN
         err_num := SQLCODE;
         err_msg := SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.CONSUMDATA', v_in, 'RSP: '||RSP);
         COMMIT;		 		     
END;
