CREATE OR REPLACE PROCEDURE TOPCENTRALETES
IS 	
  --
  -- Cursor que carregem tots els comptadors actius.
  --
  cursor result is
               SELECT t1.iddistribucio,sum(t2.consum),max(t2.consum)
			     FROM comunicaciodistribucio t1,historiclectures t2
				WHERE t1.actiu = 1
				  AND t1.IDDISTRIBUCIO IN (SELECT iddistribucio FROM distribucio WHERE actiu = 1)
				  AND t1.IDCOMPTADOR = t2.IDCOMPTADOR
				GROUP BY t1.iddistribucio
				ORDER BY 2 DESC;
  --
  -- Variables de treball
  --
  outDistribucio NUMBER;
  outEnergia     NUMBER;
  outAdreca      CHAR(30);
  outMaxim       NUMBER;
  outCapacitat   NUMBER;
  rsp            VARCHAR2(100);
  sortida        NUMBER;
  err_num        NUMBER;
  err_msg        VARCHAR2(100);  
BEGIN
  --
  -- Opertuar del cursor.
  --  
  OPEN result;  
  FETCH result INTO outDistribucio, outEnergia, outMaxim;
  -- 
  -- Capelera del llistat.
  --
  rsp := 'ADRECA                         ENERGIA         MAXIM           CAPACITAT MAXIMA';
  DBMS_OUTPUT.put_line(rsp);
  rsp := '------------------------------ --------------- --------------- ----------------';
  DBMS_OUTPUT.put_line(rsp);
  --
  -- Bucle per mostrar les dades
  --
  Sortida := 0;
  WHILE (RESULT%FOUND) AND (Sortida <= 10) LOOP        
        --
        -- MIRO L'ADRECA DE LA CENTRAL DE DISTRIBUCIO.
        --	
	    SELECT Adreca
    	  INTO outAdreca
          FROM DISTRIBUCIO
         WHERE IDDISTRIBUCIO = outDistribucio
           AND ROWNUM = 1;
	   -- 
	   -- Busco la capacitat maxima que li pot arribat
	   --
	   BEGIN
	     SELECT Max(capacitatmaxima)
		   INTO outCapacitat
		  FROM liniacomunicacio
		 WHERE actiu = 1
		   AND idliniacomunicacio IN (SELECT idliniacomunicacio FROM comunicacioproduccio WHERE actiu = 1 AND iddistribucio = outDistribucio)
		   AND ROWNUM = 1;		   
	   EXCEPTION 
	     WHEN NO_DATA_FOUND THEN outCapacitat := 0;
	   END;
       --	   
       -- MOSTREM LES DADES
       --
       rsp := outAdreca||' '||to_char(outEnergia,'999,999,999.99')||' '||to_char(outMaxim,'999,999,999.99')||' '||to_char(outCapacitat,'9999,999,999.99');
       DBMS_OUTPUT.put_line(rsp);		
       FETCH result INTO outDistribucio, outEnergia, outMaxim;  
       Sortida := Sortida + 1;
  END LOOP;
  -- Fi de la consulta
  CLOSE result;
  --
  -- Excepcions 
  --
  EXCEPTION
    WHEN OTHERS THEN
         err_num := SQLCODE;
         err_msg := SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.TOPCENTRALETES', '' , 'RSP: '||RSP);
         COMMIT;		 		     
END;
