CREATE OR REPLACE PROCEDURE TOPCOMUNICACIO
IS 
  --	
  -- Cursor que carregem tots els comptadors actius.
  --
cursor result is
          select t1.idliniacomunicacio,t1.capacitatmaxima,
                 round((select sum(consum)
                          from historiclectures
                         where idcomptador in (select idcomptador
                                                 from comunicaciodistribucio
                                                where actiu = 1
                                                  and iddistribucio in (select iddistribucio 
                                                                          from comunicacioproduccio
                                                                         where actiu = 1
                                                                           and idliniacomunicacio in (select idliniacomunicacio
                                                                                                        from liniacomunicacio 
                                                                                                       where actiu = 1 
      												         and idliniacomunicacio = t1.idliniacomunicacio))))/t1.capacitatmaxima*100,0)
                 from liniacomunicacio t1
                where t1.actiu = 1
                  and rownum <= 10
                order by 3 desc;
  -- Variables de treball			   			   			   
  outLinia       NUMBER;
  outAmpliacio   NUMBER;
  outCarrega     NUMBER;
  outMaxim       NUMBER;
  outFabricat    NUMBER;
  outConsum      NUMBER;
  rsp            VARCHAR2(100);
  err_num        NUMBER;
  err_msg        VARCHAR2(100);  
BEGIN
  -- Opertura del cursor
  OPEN result;  
  FETCH result INTO outLinia, outMaxim, outConsum;
  --
  -- Capelera del llistat
  --
  rsp := 'IDENTIFICACIO CARREGA  CONSUM          PRODUCCIO       AMPLIACIO      ';
  DBMS_OUTPUT.put_line(rsp);
  rsp := '------------- -------- --------------- --------------- ---------------';
  DBMS_OUTPUT.put_line(rsp);
  --
  -- Linies del llistat.
  --
  WHILE RESULT%FOUND LOOP  
        outCarrega := 0;
		if (outMaxim > 0) And (outConsum <> 0) then
		   outCarrega := outConsum / outMaxim; 
		end if;			
		--
		-- SUMENT TOTES LES PRODUCCIONS DE LA LINIA DE COMUNICACIO PER SABER EL QUE ES POT AMBPLIAR.
		--			
		BEGIN									
		SELECT sum(consumactual)
		  INTO outFabricat
		  FROM produccio
		 WHERE idProduccio In (Select idproduccio from comunicacioproduccio where idliniacomunicacio = outLinia);		  
	    EXCEPTION
		  WHEN NO_DATA_FOUND THEN outFabricat := 0;
		END;	
		--
		-- SUMENT TOT EL CONSUM DELS COMPTADORS D'AQUESTA LINIA.
		--
		BEGIN
		  SELECT sum(consum)
		    INTO outConsum
		    FROM historiclectures
		  WHERE idcomptador in (select idcomptador
                                  from comunicaciodistribucio
                                 where actiu = 1
                                   and iddistribucio in (select iddistribucio 
                                                          from comunicacioproduccio
                                                         where actiu = 1
                                                           and idliniacomunicacio = outLinia));
		EXCEPTION
		 WHEN NO_DATA_FOUND THEN outConsum := 0;
		END;
		
		outAmpliacio := outFabricat - outConsum;
		
        rsp := to_char(outLinia,'999999999999')||' '||to_char(outCarrega,'99.9999')||' '||to_char(outConsum,'999,999,999.99')||' '||to_char(outFabricat,'999,999,999.99')||' '||to_char(outAmpliacio,'999,999,999.99');
        DBMS_OUTPUT.put_line(rsp);
		
        FETCH result INTO outLinia, outMaxim, outConsum;
  
  END LOOP;
  -- Fi del llistat.
  CLOSE result;
  --
  -- Excepcions
  -- 
  EXCEPTION
    WHEN OTHERS THEN
         err_num := SQLCODE;
         err_msg := SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.TOPCENTRALETES', '' , 'RSP: '||RSP);
         COMMIT;		 		     
END;
