CREATE OR REPLACE PROCEDURE CLIENTSCOMPTADORS
IS
  -- 	
  -- Cursor que carregem tots els comptadors actius.
  --
  cursor result is 
               SELECT T1.IDCLIENT,(SELECT NIFCLIENT FROM CLIENTS WHERE CLIENTS.IDCLIENT = T1.IDCLIENT),T1.IDCOMPTADOR, T1.IDCONTRACTE,T2.NOMMODEL
                 FROM COMPTADORS T1, MODEL T2
                WHERE T1.IDMODEL = T2.IDMODEL
                  AND T1.ACTIU = 1
                  AND T1.IDCLIENT IN (SELECT IDCLIENT FROM CLIENTS WHERE ACTIU = 1)
             ORDER BY T1.IDCLIENT;
  -- Variables de treball				  
  outNif        CHAR(15);
  outContracte  CHAR(15);
  outModel      CHAR(30);
  outAlta       NUMBER;
  outCodi       NUMBER;
  outComptador  NUMBER;
  ok            NUMBER;
  hihies        VARCHAR2(1);
  rsp           VARCHAR2(100);
  err_num       NUMBER;
  err_msg       VARCHAR2(100);
BEGIN
  -- Opertura del cursor amb els comptadors.
  OPEN result;  
  FETCH result INTO outCodi, outNif, outComptador, outContracte, outModel;
  -- Capcelera del llistat.
  rsp := 'NIF             Contracte       Model';
  DBMS_OUTPUT.put_line(rsp);
  rsp := '--------------- --------------- --------------------';
  DBMS_OUTPUT.put_line(rsp);
  -- Mostrem les linies.
  WHILE RESULT%FOUND LOOP  
        -- MIRO SI TE CENTRAL DE DISTRIBUCIO.
		Ok := 0;		
		BEGIN		
		  SELECT 'Y'
		    INTO hihies
            FROM COMUNICACIODISTRIBUCIO
           WHERE IDCOMPTADOR = outComptador
             AND ACTIU = 1
             AND IDDISTRIBUCIO IN (SELECT IDDISTRIBUCIO FROM DISTRIBUCIO WHERE ACTIU = 1) 
             AND ROWNUM = 1;			 
			 ok := 1;			 
		  EXCEPTION			 
			 WHEN NO_DATA_FOUND THEN Ok := 0;
		END;		
		-- MIRO SI TE LINES DE COMUNICACIO I CENTRAL PRODUCCIO.
		Ok := 0;
		BEGIN		  
		  SELECT 'Y'
		    INTO hihies
            FROM COMUNICACIOPRODUCCIO
           WHERE IDLINIACOMUNICACIO IN (SELECT IDLINIACOMUNICACIO FROM LINIACOMUNICACIO WHERE ACTIU = 1)
             AND IDPRODUCCIO IN (SELECT IDPRODUCCIO FROM PRODUCCIO WHERE ACTIU = 1)
             AND IDDISTRIBUCIO IN (SELECT IDDISTRIBUCIO FROM COMUNICACIODISTRIBUCIO WHERE ACTIU = 1 AND IDCOMPTADOR = outComptador)		
			 AND ROWNUM = 1;			 
			 ok := 1;			 
		  EXCEPTION			 
			 WHEN NO_DATA_FOUND THEN Ok := 0;		
		END;		  
        IF (OK = 1) THEN
		    -- TOT ESTA ACTIU. PER ULTIM MIREM SI ES D'ALTA DISPONIBILITAT.
     		BEGIN		
		      SELECT Count(*)
     		    INTO outAlta
                FROM COMUNICACIODISTRIBUCIO
               WHERE IDCOMPTADOR = outComptador
                 AND ACTIU = 1
                 AND IDDISTRIBUCIO IN (SELECT IDDISTRIBUCIO FROM DISTRIBUCIO WHERE ACTIU = 1);
	        EXCEPTION			 
			 WHEN NO_DATA_FOUND THEN outAlta := 0;
    		END;		
			-- Mostrem les dades
			IF (OUTALTA >= 2) THEN 
               rsp := outNif||' '||outContracte||' '||outModel;
               DBMS_OUTPUT.put_line(rsp);
			END IF;
		END IF;		
        FETCH result INTO outCodi, outNif, outComptador, outContracte, outModel;  
  END LOOP;
  -- Fi del llsita
  CLOSE result;
  --
  -- Excepcions
  -- 
  EXCEPTION
    WHEN OTHERS THEN
         err_num := SQLCODE;
         err_msg := SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.CLIENTSCOMPTADORS', '' , 'RSP: '||RSP);
         COMMIT;		 		     
END;
