CREATE OR REPLACE PROCEDURE CONSULTAVELLS(Antiguetat in INTEGER)
IS
  -- 	
  -- Cursor que carregem tots els comptadors actius.
  --
  cursor result is 
               SELECT idcontracte,anyfabricacio,to_char(SysDate,'YYYY') - AnyFabricacio as temps
                  FROM comptadors
                  WHERE actiu=1;   
  -- Variables de treball				  				    	
  V_CAMP_NUL    EXCEPTION;
  v_in          VARCHAR2(500);
  rsp           varchar2(100);
  err_num       NUMBER;
  err_msg       VARCHAR2(100);  
BEGIN
  v_in := 'Any:'||Antiguetat;
  --
  -- Comprovar que parametre d'entrada
  --
  IF (TRIM(Antiguetat)     IS NULL) THEN
     RAISE V_CAMP_NUL;
  END IF;
  --
  -- Obrim el cursor
  --
  OPEN result;
  --
  -- Bucle per mostrar les dades
  --  
  FOR r IN result LOOP
      --
      -- Comprovacio de l'antiguitat.
	  --
      IF (r.temps > antiguetat) then
         rsp := 'Contracte : '||r.idcontracte||', Fabricacio : '||r.anyfabricacio||', Antiguetat : '||r.temps;
         DBMS_OUTPUT.put_line(rsp);
      END IF;  
  END LOOP;
  -- Fi de la consulta
  CLOSE result;
  --
  -- Excepcions
  --  
  EXCEPTION
    WHEN V_CAMP_NUL THEN
         RSP := 'ERROR: No pot haver camps NULL';
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.CONSULTAVELLS', v_in, 'RSP: '||RSP);
         DBMS_OUTPUT.put_line(rsp);
         COMMIT;
    WHEN OTHERS THEN
         err_num := SQLCODE;
         err_msg := SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
         INSERT INTO LOGS (DATA, PROCEDIMENT, PARAMSIN, PARAMSOUT)
                VALUES (SYSDATE,'PROCEDURE.CONSULTAVELLS', v_in, 'RSP: '||RSP);
         COMMIT;		 		     
END;
