spool 6-triggers.log
--
--TRIGERS DE GENERACIO DE SEQUENCIAS PREVIES A LA INSERCIO.
--
-- LOG.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_LOGS
BEFORE INSERT ON LOGS FOR EACH ROW 
BEGIN
 SELECT SQ_IDLOGS.NEXTVAL 
   INTO :NEW.IDLOGS
   FROM DUAL; 
END TR_BEF_INS_LOGS;              
--
-- CLIENTS.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_CLIENTS
BEFORE INSERT ON CLIENTS FOR EACH ROW 
BEGIN
 SELECT SQ_IDCLIENT.NEXTVAL 
   INTO :NEW.IDCLIENT
   FROM DUAL; 
END TR_BEF_INS_CLIENTS;              
--
-- COMPTADORS.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_COMPTADORS          
BEFORE INSERT ON COMPTADORS FOR EACH ROW 
BEGIN
 SELECT SQ_IDCOMPTADORS.NEXTVAL 
   INTO :NEW.IDCOMPTADOR      
   FROM DUAL; 
 -- ACTUALITZO COMPTADORS DEL CLIENT
 UPDATE CLIENTS
    SET COMPTADORS = COMPTADORS + 1
  WHERE IDCLIENT = :NEW.IDCLIENT;
     
END TR_BEF_INS_COMPTADORS;              
--
-- LINIA COMUNICACIO.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_LINIACOMUNICACIO
BEFORE INSERT ON LINIACOMUNICACIO FOR EACH ROW 
BEGIN
 SELECT SQ_IDLINIACOMUNICACIO.NEXTVAL 
   INTO :NEW.IDLINIACOMUNICACIO
   FROM DUAL; 
 -- HISTORIC ANY TREBALL.
 --   
 INSERT INTO HISTORICANY (BD, IDCLAU,IDANY, PRODUCCIO, CONSUM, PRODUCCIOTOTAL, CONSUMTOTAL, CONSUMAVG)
           VALUES (0, :NEW.IDLINIACOMUNICACIO, TO_char(SYSDATE,'YYYY'), 0, 0, 0, 0, 0); 
    
END TR_BEF_INS_LINIACOMUNICACIO;           
--
-- CENTRAL PRODUCCIO.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_PRODUCCIO
BEFORE INSERT ON PRODUCCIO FOR EACH ROW 
BEGIN
 SELECT SQ_IDPRODUCCIO.NEXTVAL 
   INTO :NEW.IDPRODUCCIO
   FROM DUAL; 
 -- HISTORIC ANY TREBALL.
 --   
 INSERT INTO HISTORICANY (BD, IDCLAU,IDANY, PRODUCCIO, CONSUM, PRODUCCIOTOTAL, CONSUMTOTAL, CONSUMAVG)
           VALUES (1, :NEW.IDPRODUCCIO, TO_char(SYSDATE,'YYYY'), 0, 0, 0, 0, 0); 
   
END TR_BEF_INS_PRODUCCIO;      
--
-- CENTRAL DISTRIBUCIO.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_DISTRIBUCIO 
BEFORE INSERT ON DISTRIBUCIO FOR EACH ROW 
BEGIN
 SELECT SQ_IDDISTRIBUCIO.NEXTVAL 
   INTO :NEW.IDDISTRIBUCIO
   FROM DUAL; 
END TR_BEF_INS_DISTRIBUCIO;
--
-- COMUNICACIO DISTRIBUCIO.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_COM_DISTRIBUCIO
BEFORE INSERT ON COMUNICACIODISTRIBUCIO FOR EACH ROW 
BEGIN
 SELECT SQ_IDCOM_DISTRIBUCIO.NEXTVAL 
   INTO :NEW.ID
   FROM DUAL; 
END TR_BEF_INS_COM_DISTRIBUCIO;
--
-- COMUNICACIO PRODUCCIO.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_COM_PRODUCCIO
BEFORE INSERT ON COMUNICACIOPRODUCCIO FOR EACH ROW 
BEGIN
 SELECT SQ_IDCOM_PRODUCCIO.NEXTVAL 
   INTO :NEW.ID
   FROM DUAL; 
END TR_BEF_INS_COM_PRODUCCIO;



--
-- HISTORIC LECTURES.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_HISTORICLECTURES
BEFORE INSERT ON HISTORICLECTURES FOR EACH ROW
BEGIN
 SELECT SQ_IDHIS_LECTURES.NEXTVAL 
   INTO :NEW.ID
   FROM DUAL; 
 -- ACTUALITZEM DADES COMPTADORS.
 UPDATE COMPTADORS SET
        CONSUMACTUAL = :NEW.CONSUMACTUAL,
        DATALECTURA = :NEW.DATALECTURA
 WHERE IDCOMPTADOR = :NEW.IDCOMPTADOR;
 -- ACTUALITZEM DADES DEL CLIENT.
 UPDATE CLIENTS SET
        CONSUMTOTAL = CONSUMTOTAL + :NEW.CONSUM 
 WHERE IDCLIENT = (SELECT IDCLIENT
                     FROM COMPTADORS
                    WHERE ACTIU = 1
					  AND IDCOMPTADOR = :NEW.IDCOMPTADOR
					  AND ROWNUM = 1);

 -- ACTUALITZEM DADES CENTRAL DE PRODUCCIO.
 UPDATE PRODUCCIO
    SET CONSUMSCOMPTADOR = CONSUMSCOMPTADOR + :NEW.CONSUM
  WHERE ACTIU = 1
    AND IDPRODUCCIO IN (SELECT DISTINCT(IDPRODUCCIO) FROM COMUNICACIOPRODUCCIO WHERE ACTIU = 1 AND IDDISTRIBUCIO 
	                IN (SELECT DISTINCT(IDDISTRIBUCIO) FROM COMUNICACIODISTRIBUCIO WHERE IDCOMPTADOR = :NEW.IDCOMPTADOR AND ACTIU = 1));
					   												     												   					 
END TR_BEF_INS_HISTORICLECTURES;
--
CREATE OR REPLACE TRIGGER ELE.TR_AFT_INS_HISTORICLECTURES
AFTER INSERT ON HISTORICLECTURES FOR EACH ROW 
BEGIN
 -- ACTUALITZEM DADES CLIENTS.
 UPDATE CLIENTS
    SET CONSUMMIG = CONSUMTOTAL / COMPTADORS
  WHERE IDCLIENT = (SELECT IDCLIENT 
                      FROM COMPTADORS 
        		     WHERE ACTIU = 1
                       AND IDCOMPTADOR = :NEW.IDCOMPTADOR 
					   AND ROWNUM = 1);
					 
END TR_AFT_INS_HISTORICLECTURES;


--
-- HISTORIC PRODUCCIO.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_HISTORICPRODUCCIO
BEFORE INSERT ON HISTORICPRODUCCIO FOR EACH ROW 
BEGIN
 SELECT SQ_IDHIS_PRODUCCIO.NEXTVAL 
   INTO :NEW.ID
   FROM DUAL; 
 -- SUMENT LA PRODUCCIO .
 -- ACTUALITZEM SI EL VALOR ES MAJOR.  
 UPDATE PRODUCCIO SET
    CONSUMACTUAL = CONSUMACTUAL + :NEW.KILOWATS,
	ENERGIAMAXIMA = GREATEST(ENERGIAMAXIMA, :NEW.KILOWATS)
 WHERE IDPRODUCCIO = :NEW.IDPRODUCCIO;
END TR_BEF_INS_HISTORICPRODUCCIO;

--
-- HISTORIC ANY.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_HISTORICANY
BEFORE INSERT ON HISTORICANY FOR EACH ROW 
BEGIN
 SELECT SQ_IDHIS_ANY.NEXTVAL 
   INTO :NEW.ID
   FROM DUAL; 
END TR_BEF_INS_HISTORICANY;

--
-- HISTORIC TOTAL.
--
CREATE OR REPLACE TRIGGER ELE.TR_BEF_INS_HISTORICTOTAL
BEFORE INSERT ON HISTORICTOTAL FOR EACH ROW 
BEGIN
 SELECT SQ_IDHIS_TOTAL.NEXTVAL 
   INTO :NEW.ID
   FROM DUAL; 
END TR_BEF_INS_HISTORICTOTAL;


spool off;
